/*
 * montecarlo_pi.c
 *
 * Computes Pi through statistic approximation
 *
 * Compile with: gcc -Wall montecarlo_pi.c -o montecarlo_pi_vis
 * Execute with: ./montecarlo_pi 100000
 *
 * Author: Xavier Bourgeois
 * Date: 2025-04-09
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int main(int argc, char **argv) {
	unsigned long n;
	double x, y;
	unsigned long count = 0;
	unsigned long i;
	//double result = 0;
	srand((unsigned)time(NULL));

	if(argc < 1)
		return 1;
	if(argv[1] < 0)
		return 1;
	else
		n = atoi(argv[1]) * 1024;

	for(i=0; i<n; i++) {
		x = (double) rand() / RAND_MAX;
		y = (double) rand() / RAND_MAX;
		count += (x*x+y*y < 1);
		//if(x*x+y*y < 1)
		//	count++;
	}
	//result = (double) 4 * count / n;
	printf("%f\n", (double) 4 * count / n);

	return 0;
}

