/*
 * montecarlo_pi.go
 *
 * Computes Pi through statistic approximation
 *
 * Compile with: go build montecarlo_pi.go
 * Execute with: ./montecarlo_pi 100000
 *
 * Author: Xavier Bourgeois
 * Date: 2025-04-16
 */

package main

import "fmt"
import "math/rand"
import "os"
import "strconv"

func main() {
	var n int
	var x, y float64
	var count = 0

	if len(os.Args) < 2 {
		os.Exit(1)
	}
	n, err := strconv.Atoi(os.Args[1])

	if n < 0 || err != nil {
		os.Exit(1)
	}
	n *= 1024

	for i := 0; i <= n; i++ {
		x = rand.Float64()
		y = rand.Float64()
		if x*x+y*y < 1 {
			count++;
		}
	}
	fmt.Println(4*float64(count)/float64(n))
	os.Exit(0)
}
