#!/bin/bash
# montecarlo_pi.sh
#
# Computes Pi through statistic approximation
#
# Execute with: bash montecarlo_pi 100
# Warning: slow and uses lots of RAM
#
# Author: Xavier Bourgeois
# Date: 2025-04-20

if [ ! ${BASH_ARGC} -eq 1 ]; then
	exit 1
fi

if [ ! ${BASH_ARGV[0]} -gt 0 ]; then
	exit 1
fi

let n=1024*${BASH_ARGV[0]}
count=0
MAX_INT=1073741823

for i in $(seq 0 $n):
	do let x=$RANDOM
	let y=$RANDOM
	let circle=$x**2+$y**2
	if [ $circle -lt $MAX_INT ]; then
		let count=$count+1
	fi
done

pi=$(awk "BEGIN { print 4 * $count / $n }")
echo $pi
